#include "ord.ch"
#include "dbinfo.ch"
#include "set.ch"

// compile with Clipper 5.3  /l /n /v /r /w

func cmxAutoOpen(lAutoOpen)
return Set(_SET_AUTOPEN, lAutoOpen)

func cmxAutoOrder(nAutoOrder)
return Set(_SET_AUTORDER, nAutoOrder)

func cmxAutoShare(nAutoShare)
return Set(_SET_AUTOSHARE, nAutoShare)

func cmxClrScope(nScope)
	ordScope(nScope, nil)
return nil

func cmxCount(cBag)
return dbOrderInfo(DBOI_ORDERCOUNT, cBag)

func cmxCustom(xOrder, cBag, lCustom)
return dbOrderInfo(DBOI_CUSTOM, cBag, xOrder, lCustom)

func cmxDescend(xOrder, cBag, lDescend)
return dbOrderInfo(DBOI_ISDESC, cBag, xOrder, lDescend)

func cmxFor(xOrder, cBag, cFor)
return dbOrderInfo(DBOI_CONDITION, cBag, xOrder, cFor)

func cmxIndexInfo()
	local nOrdCount := cmxCount()
	local aInfo[6, nOrdCount]
	local i
	for i := 1 to nOrdCount
	    aInfo[1, i] = ordName(i)
	    aInfo[2, i] = ordKey(i)
	    aInfo[3, i] = ordFor(i)
	    aInfo[4, i] = cmxUnique(i)
	    aInfo[5, i] = cmxDescend(i)
	    aInfo[6, i] = cmxCustom(i)
	next i
return aInfo

func cmxKeyAdd(xOrder, cBag)
return ordKeyAdd(xOrder, cBag)

func cmxKeyCount(xOrder, cBag)
return dbOrderInfo(DBOI_KEYCOUNTRAW, cBag, xOrder)

func cmxKeyDel(xOrder, cBag)
return ordKeyDel(xOrder, cBag)

func cmxKeyGoto(nKeyno)
return ordKeyGoto(nKeyno)

func cmxKeyNo(xOrder, cBag)
return dbOrderInfo(DBOI_KEYNORAW, cBag, xOrder)

func cmxKeysIncluded()
return dbOrderInfo(DBOI_KEYSINCLUDED)

func cmxKeySkip(nCount)
return dbSkip(nCount)

func cmxKeyVal()
return ordKeyVal()

func cmxMemoBlock(nSize)
return dbInfo(DBI_MEMOBLOCKSIZE, nSize)
		
func cmxMemoExt()
return dbInfo(DBI_MEMOEXT)

func cmxRollback()
return dbRecordInfo(DBRI_UPDATED, recno(), .f.)

func cmxSeekLast(xVal, lSoft)
	local lFound
	local lDescend := ordDescend()
	ordDescend(,, !lDescend)
	lFound := dbSeek(xVal, lSoft)
	ordDescend(,, lDescend)
return lFound

func cmxSetRelation(cAlias, bKey, cKey)
return ordSetRelation(cAlias, bKey, cKey)

func cmxSetScope(nKey, xVal)
return iif(pcount() <= 1, ordScope(nKey), ordScope(nKey, xVal))

func cmxShared(lShared)
	local lPrevShared := dbInfo(DBI_SHARED)
	if (valType(lShared) == 'L')
		dbInfo(DBI_SHARED, lShared)
	endif
return lPrevShared

func cmxSkipUnique(nCount)
return ordSkipUnique(nCount)

func cmxSys(nRequest, lSetting)
	local lPrev := .f.

	do case

	case nRequest == 1001
		lPrev := Set(_SET_STRICTREAD)
		if valType(lSetting) == 0
			Set(_SET_STRICTREAD, lSetting)
		endif

		//	Always does hard commits (always true)
	case nRequest == 1002
		lPrev := .t.

	endcase
return lPrev

func cmxUnique(xOrder, cBag)
return ordIsUnique(xOrder, cBag)

func cmxVersion(nVer)
	static cVer := "3.00.07 (Comix/5.3)"
	static anOfs := { 4, 7, 19 }

	if (valType(nVer) != 'N')
		nVer := 0
	endif
	if (nVer < 0)
		nVer = 0
	endif
	if (nVer > 2)
		nVer = 2
	endif

return left(cVer, anOfs[nVer+1])

